package cologne.eck.peafactory.peas.gui;

import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;


@SuppressWarnings("serial")
public class PeaFolderChooser extends PeaFileChooser {

	/**
	 * 	The previously selected folder to remember
	 * and to use as start location next time
	 */
	private static File lastFolder;
	
	/**
	 * A JFileChooser which displays both files and
	 * directories but allows only the selection of
	 * directories
	 * 
	 * @param comp the parent component
	 */
	public PeaFolderChooser(Component comp) {
		super(comp);
		
		if (System.getProperty("os.name").startsWith("Mac OS X")) {
			// on MAc files are shown gray and can't be chosen, 
			// this is a better option 
		    this.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		} else {
		    this.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		    this.setApproveButtonText("Choose directory");
		}
		if (lastFolder != null) {
			this.setSelectedFile(lastFolder);
		}
	}

	/*
	 * If a file was selected: do nothing.
	 * 
	 * (non-Javadoc)
	 * @see javax.swing.JFileChooser#approveSelection()
	 */
	@Override
    public void approveSelection() {
        if (getSelectedFile().isFile()) {
            return;
        } else {
            super.approveSelection();
        }
        lastFolder = getSelectedFile();
    }
}
