package cologne.eck.peafactory.peas.image_pea;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import cologne.eck.peafactory.tools.ReadResources;
import cologne.eck.peafactory.tools.WriteResources;

public class ZipStuff {

	
	static final int BUFFER_SIZE = 1024 * 1024;//8192;
	
	public ZipStuff() {
		// TODO Auto-generated constructor stub
	}
	
	protected static boolean zipFolder(String folderName, String zipName) {
		
		File folder = new File(folderName);
		if (! folder.exists()) {
			System.err.println("ZipStuff: directory to zip does not exist");
			return false;
		}
		if (! folder.canRead()){
			System.err.println("ZipStuff: can not read directory to zip");
			return false;			
		}
		if (! folder.isDirectory()){
			System.err.println("ZipStuff: file to zip is not directory");
			return false;
		}
		
	    try {
	    	BufferedInputStream origin = null;
	        FileOutputStream dest = new FileOutputStream(zipName);
	        // target zip output stream
	        ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(dest));
	        //out.setMethod(ZipOutputStream.DEFLATED);
	        byte data[] = new byte[BUFFER_SIZE];
	        // get a list of files from directory
	        String files[] = folder.list();

	        for (int i=0; i<files.length; i++) {
	        	//System.out.println("Adding: "+files[i]);
	            FileInputStream fi = new FileInputStream(folderName + File.separator + files[i]);
	            origin = new BufferedInputStream(fi, BUFFER_SIZE);
	            ZipEntry entry = new ZipEntry(files[i]);
	            out.putNextEntry(entry);
	            int count;
	            while((count = origin.read(data, 0, 
	               BUFFER_SIZE)) != -1) {
	            	out.write(data, 0, count);
	            }
	             	origin.close();
	        }
	        out.close();

	    } catch (FileNotFoundException e) {
	    	e.printStackTrace();
			System.err.println(e.toString() + ", " + e.getMessage());			
			return false;
		} catch (IOException e) {
	    	e.printStackTrace();
			System.err.println(e.toString() + ", " + e.getMessage());	
			return false;
		} catch (Exception e) {
	    	e.printStackTrace();
			System.err.println(e.toString() + ", " + e.getMessage());			
			return false;			
		}
	    


		return true;
	}
	
	protected static byte[] getFileFromZip(String fileName, String zipName) {
		
		File zipFile = new File(zipName);
		if (! zipFile.exists()) {
			System.err.println("ZipStuff: zip file does not exist");
			return null;
		}
		if (! zipFile.canRead()){
			System.err.println("ZipStuff: can not read zip file");
			return null;
		}
		if (zipFile.isDirectory()){
			System.err.println("ZipStuff: zip file is directory");
			return null;
		}
//		try {
//	         BufferedOutputStream dest = null;
	         FileInputStream fis = null;
			try {
				fis = new FileInputStream(zipFile);
		         ZipInputStream zis = new ZipInputStream(new BufferedInputStream(fis));
		         ZipEntry entry;
		         while((entry = zis.getNextEntry()) != null) {
		            //System.out.println("Extracting: " +entry);
		        	 
		        	 if (entry.getName().endsWith(fileName)){
		 	            //FileOutputStream fos = new FileOutputStream(entry.getName());
		        		 ByteArrayOutputStream buffOut = new ByteArrayOutputStream(BUFFER_SIZE);
		        		 byte[] buffer = new byte[BUFFER_SIZE];
		                 int bytesRead = 0;
		                 while ((bytesRead = zis.read(buffer)) != -1) {
		                     buffOut.write(buffer, 0, bytesRead);
		                 }		        		 
		        		 
		        		 return (buffOut == null) ? null : buffOut.toByteArray();
		        	 }

		         }
		         fis.close();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;

		}
	
		protected static void addFileToZip(String fileName, String oldZipName) {
			
			
		       // read war.zip and write to append.zip
	        ZipFile zipFile;
			try {
				zipFile = new ZipFile(oldZipName);
		        ZipOutputStream zipStream = new ZipOutputStream(new FileOutputStream("test/tmp.zip"));

		        // first, copy contents from existing war
		        Enumeration<? extends ZipEntry> entries = zipFile.entries();
		        while (entries.hasMoreElements()) {
		            ZipEntry e = entries.nextElement();
		            byte[] buffer = new byte[BUFFER_SIZE];
		           // System.out.println("copy: " + e.getName());
		            zipStream.putNextEntry(e);
		            if (!e.isDirectory()) {
		            	InputStream input = zipFile.getInputStream(e);//, OutputStream output
		                //copy(war.getInputStream(e), append);
		                int bytesRead;
		                while ((bytesRead = input.read(buffer))!= -1) {
		                    zipStream.write(buffer, 0, bytesRead);
		                }

		            }
		            //append.closeEntry();
		        }

		        // now append some extra content
		        ZipEntry e = new ZipEntry(fileName);
		        //System.out.println("append: " + e.getName());
		        zipStream.putNextEntry(e);
	//	        zipStream.write("42\n".getBytes());
		        zipStream.write(ReadResources.readExternFile("test" + File.separator +  e.getName()));
		        zipStream.closeEntry();

		        // close
		        zipFile.close();
		        zipStream.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
		    File oldFile = new File(oldZipName);
		    oldFile.delete();
		    
		    File tmpFile = new File("test/tmp.zip");
		    tmpFile.renameTo(oldFile);

		}
	
		public static void main(String[] args) {
			ZipStuff.zipFolder("test/testFolder", "test/test.zip");
		
			byte[] content = ZipStuff.getFileFromZip("P1010019.JPG", "test/test.zip");
			WriteResources.write(content, "newFile", "test");
			ZipStuff.addFileToZip("newFile", "test/test.zip");
	}
}
